// Compiled by ClojureScript 1.7.122 {:elide-asserts true}
goog.provide('figwheel.client');
goog.require('cljs.core');
goog.require('goog.userAgent.product');
goog.require('goog.Uri');
goog.require('cljs.core.async');
goog.require('figwheel.client.socket');
goog.require('figwheel.client.file_reloading');
goog.require('clojure.string');
goog.require('figwheel.client.utils');
goog.require('cljs.repl');
goog.require('figwheel.client.heads_up');
figwheel.client.figwheel_repl_print = (function figwheel$client$figwheel_repl_print(args){
figwheel.client.socket.send_BANG_.call(null,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"figwheel-event","figwheel-event",519570592),"callback",new cljs.core.Keyword(null,"callback-name","callback-name",336964714),"figwheel-repl-print",new cljs.core.Keyword(null,"content","content",15833224),args], null));

return args;
});
if(typeof figwheel.client.autoload !== 'undefined'){
} else {
figwheel.client.autoload = cljs.core.atom.call(null,true);
}
figwheel.client.toggle_autoload = (function figwheel$client$toggle_autoload(){
return cljs.core.swap_BANG_.call(null,figwheel.client.autoload,cljs.core.not);
});
goog.exportSymbol('figwheel.client.toggle_autoload', figwheel.client.toggle_autoload);
figwheel.client.console_print = (function figwheel$client$console_print(args){
console.log.apply(console,cljs.core.into_array.call(null,args));

return args;
});
figwheel.client.enable_repl_print_BANG_ = (function figwheel$client$enable_repl_print_BANG_(){
cljs.core._STAR_print_newline_STAR_ = false;

return cljs.core._STAR_print_fn_STAR_ = (function() { 
var G__24070__delegate = function (args){
return figwheel.client.figwheel_repl_print.call(null,figwheel.client.console_print.call(null,args));
};
var G__24070 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__24071__i = 0, G__24071__a = new Array(arguments.length -  0);
while (G__24071__i < G__24071__a.length) {G__24071__a[G__24071__i] = arguments[G__24071__i + 0]; ++G__24071__i;}
  args = new cljs.core.IndexedSeq(G__24071__a,0);
} 
return G__24070__delegate.call(this,args);};
G__24070.cljs$lang$maxFixedArity = 0;
G__24070.cljs$lang$applyTo = (function (arglist__24072){
var args = cljs.core.seq(arglist__24072);
return G__24070__delegate(args);
});
G__24070.cljs$core$IFn$_invoke$arity$variadic = G__24070__delegate;
return G__24070;
})()
;
});
figwheel.client.get_essential_messages = (function figwheel$client$get_essential_messages(ed){
if(cljs.core.truth_(ed)){
return cljs.core.cons.call(null,cljs.core.select_keys.call(null,ed,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"message","message",-406056002),new cljs.core.Keyword(null,"class","class",-2030961996)], null)),figwheel$client$get_essential_messages.call(null,new cljs.core.Keyword(null,"cause","cause",231901252).cljs$core$IFn$_invoke$arity$1(ed)));
} else {
return null;
}
});
figwheel.client.error_msg_format = (function figwheel$client$error_msg_format(p__24073){
var map__24076 = p__24073;
var map__24076__$1 = ((((!((map__24076 == null)))?((((map__24076.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24076.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24076):map__24076);
var message = cljs.core.get.call(null,map__24076__$1,new cljs.core.Keyword(null,"message","message",-406056002));
var class$ = cljs.core.get.call(null,map__24076__$1,new cljs.core.Keyword(null,"class","class",-2030961996));
return [cljs.core.str(class$),cljs.core.str(" : "),cljs.core.str(message)].join('');
});
figwheel.client.format_messages = cljs.core.comp.call(null,cljs.core.partial.call(null,cljs.core.map,figwheel.client.error_msg_format),figwheel.client.get_essential_messages);
figwheel.client.focus_msgs = (function figwheel$client$focus_msgs(name_set,msg_hist){
return cljs.core.cons.call(null,cljs.core.first.call(null,msg_hist),cljs.core.filter.call(null,cljs.core.comp.call(null,name_set,new cljs.core.Keyword(null,"msg-name","msg-name",-353709863)),cljs.core.rest.call(null,msg_hist)));
});
figwheel.client.reload_file_QMARK__STAR_ = (function figwheel$client$reload_file_QMARK__STAR_(msg_name,opts){
var or__16396__auto__ = new cljs.core.Keyword(null,"load-warninged-code","load-warninged-code",-2030345223).cljs$core$IFn$_invoke$arity$1(opts);
if(cljs.core.truth_(or__16396__auto__)){
return or__16396__auto__;
} else {
return cljs.core.not_EQ_.call(null,msg_name,new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356));
}
});
figwheel.client.reload_file_state_QMARK_ = (function figwheel$client$reload_file_state_QMARK_(msg_names,opts){
var and__16384__auto__ = cljs.core._EQ_.call(null,cljs.core.first.call(null,msg_names),new cljs.core.Keyword(null,"files-changed","files-changed",-1418200563));
if(and__16384__auto__){
return figwheel.client.reload_file_QMARK__STAR_.call(null,cljs.core.second.call(null,msg_names),opts);
} else {
return and__16384__auto__;
}
});
figwheel.client.block_reload_file_state_QMARK_ = (function figwheel$client$block_reload_file_state_QMARK_(msg_names,opts){
return (cljs.core._EQ_.call(null,cljs.core.first.call(null,msg_names),new cljs.core.Keyword(null,"files-changed","files-changed",-1418200563))) && (cljs.core.not.call(null,figwheel.client.reload_file_QMARK__STAR_.call(null,cljs.core.second.call(null,msg_names),opts)));
});
figwheel.client.warning_append_state_QMARK_ = (function figwheel$client$warning_append_state_QMARK_(msg_names){
return cljs.core._EQ_.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356),new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356)], null),cljs.core.take.call(null,(2),msg_names));
});
figwheel.client.warning_state_QMARK_ = (function figwheel$client$warning_state_QMARK_(msg_names){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356),cljs.core.first.call(null,msg_names));
});
figwheel.client.rewarning_state_QMARK_ = (function figwheel$client$rewarning_state_QMARK_(msg_names){
return cljs.core._EQ_.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356),new cljs.core.Keyword(null,"files-changed","files-changed",-1418200563),new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356)], null),cljs.core.take.call(null,(3),msg_names));
});
figwheel.client.compile_fail_state_QMARK_ = (function figwheel$client$compile_fail_state_QMARK_(msg_names){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"compile-failed","compile-failed",-477639289),cljs.core.first.call(null,msg_names));
});
figwheel.client.compile_refail_state_QMARK_ = (function figwheel$client$compile_refail_state_QMARK_(msg_names){
return cljs.core._EQ_.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"compile-failed","compile-failed",-477639289),new cljs.core.Keyword(null,"compile-failed","compile-failed",-477639289)], null),cljs.core.take.call(null,(2),msg_names));
});
figwheel.client.css_loaded_state_QMARK_ = (function figwheel$client$css_loaded_state_QMARK_(msg_names){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"css-files-changed","css-files-changed",720773874),cljs.core.first.call(null,msg_names));
});
figwheel.client.file_reloader_plugin = (function figwheel$client$file_reloader_plugin(opts){
var ch = cljs.core.async.chan.call(null);
var c__19725__auto___24224 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___24224,ch){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___24224,ch){
return (function (state_24194){
var state_val_24195 = (state_24194[(1)]);
if((state_val_24195 === (7))){
var inst_24190 = (state_24194[(2)]);
var state_24194__$1 = state_24194;
var statearr_24196_24225 = state_24194__$1;
(statearr_24196_24225[(2)] = inst_24190);

(statearr_24196_24225[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (1))){
var state_24194__$1 = state_24194;
var statearr_24197_24226 = state_24194__$1;
(statearr_24197_24226[(2)] = null);

(statearr_24197_24226[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (4))){
var inst_24153 = (state_24194[(7)]);
var inst_24153__$1 = (state_24194[(2)]);
var state_24194__$1 = (function (){var statearr_24198 = state_24194;
(statearr_24198[(7)] = inst_24153__$1);

return statearr_24198;
})();
if(cljs.core.truth_(inst_24153__$1)){
var statearr_24199_24227 = state_24194__$1;
(statearr_24199_24227[(1)] = (5));

} else {
var statearr_24200_24228 = state_24194__$1;
(statearr_24200_24228[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (15))){
var inst_24160 = (state_24194[(8)]);
var inst_24175 = new cljs.core.Keyword(null,"files","files",-472457450).cljs$core$IFn$_invoke$arity$1(inst_24160);
var inst_24176 = cljs.core.first.call(null,inst_24175);
var inst_24177 = new cljs.core.Keyword(null,"file","file",-1269645878).cljs$core$IFn$_invoke$arity$1(inst_24176);
var inst_24178 = console.warn("Figwheel: Not loading code with warnings - ",inst_24177);
var state_24194__$1 = state_24194;
var statearr_24201_24229 = state_24194__$1;
(statearr_24201_24229[(2)] = inst_24178);

(statearr_24201_24229[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (13))){
var inst_24183 = (state_24194[(2)]);
var state_24194__$1 = state_24194;
var statearr_24202_24230 = state_24194__$1;
(statearr_24202_24230[(2)] = inst_24183);

(statearr_24202_24230[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (6))){
var state_24194__$1 = state_24194;
var statearr_24203_24231 = state_24194__$1;
(statearr_24203_24231[(2)] = null);

(statearr_24203_24231[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (17))){
var inst_24181 = (state_24194[(2)]);
var state_24194__$1 = state_24194;
var statearr_24204_24232 = state_24194__$1;
(statearr_24204_24232[(2)] = inst_24181);

(statearr_24204_24232[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (3))){
var inst_24192 = (state_24194[(2)]);
var state_24194__$1 = state_24194;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_24194__$1,inst_24192);
} else {
if((state_val_24195 === (12))){
var inst_24159 = (state_24194[(9)]);
var inst_24173 = figwheel.client.block_reload_file_state_QMARK_.call(null,inst_24159,opts);
var state_24194__$1 = state_24194;
if(cljs.core.truth_(inst_24173)){
var statearr_24205_24233 = state_24194__$1;
(statearr_24205_24233[(1)] = (15));

} else {
var statearr_24206_24234 = state_24194__$1;
(statearr_24206_24234[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (2))){
var state_24194__$1 = state_24194;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24194__$1,(4),ch);
} else {
if((state_val_24195 === (11))){
var inst_24160 = (state_24194[(8)]);
var inst_24165 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_24166 = figwheel.client.file_reloading.reload_js_files.call(null,opts,inst_24160);
var inst_24167 = cljs.core.async.timeout.call(null,(1000));
var inst_24168 = [inst_24166,inst_24167];
var inst_24169 = (new cljs.core.PersistentVector(null,2,(5),inst_24165,inst_24168,null));
var state_24194__$1 = state_24194;
return cljs.core.async.ioc_alts_BANG_.call(null,state_24194__$1,(14),inst_24169);
} else {
if((state_val_24195 === (9))){
var state_24194__$1 = state_24194;
var statearr_24207_24235 = state_24194__$1;
(statearr_24207_24235[(2)] = null);

(statearr_24207_24235[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (5))){
var inst_24153 = (state_24194[(7)]);
var inst_24155 = [new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356),null,new cljs.core.Keyword(null,"files-changed","files-changed",-1418200563),null];
var inst_24156 = (new cljs.core.PersistentArrayMap(null,2,inst_24155,null));
var inst_24157 = (new cljs.core.PersistentHashSet(null,inst_24156,null));
var inst_24158 = figwheel.client.focus_msgs.call(null,inst_24157,inst_24153);
var inst_24159 = cljs.core.map.call(null,new cljs.core.Keyword(null,"msg-name","msg-name",-353709863),inst_24158);
var inst_24160 = cljs.core.first.call(null,inst_24158);
var inst_24161 = cljs.core.deref.call(null,figwheel.client.autoload);
var state_24194__$1 = (function (){var statearr_24208 = state_24194;
(statearr_24208[(9)] = inst_24159);

(statearr_24208[(8)] = inst_24160);

return statearr_24208;
})();
if(cljs.core.truth_(inst_24161)){
var statearr_24209_24236 = state_24194__$1;
(statearr_24209_24236[(1)] = (8));

} else {
var statearr_24210_24237 = state_24194__$1;
(statearr_24210_24237[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (14))){
var inst_24171 = (state_24194[(2)]);
var state_24194__$1 = state_24194;
var statearr_24211_24238 = state_24194__$1;
(statearr_24211_24238[(2)] = inst_24171);

(statearr_24211_24238[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (16))){
var state_24194__$1 = state_24194;
var statearr_24212_24239 = state_24194__$1;
(statearr_24212_24239[(2)] = null);

(statearr_24212_24239[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (10))){
var inst_24186 = (state_24194[(2)]);
var state_24194__$1 = (function (){var statearr_24213 = state_24194;
(statearr_24213[(10)] = inst_24186);

return statearr_24213;
})();
var statearr_24214_24240 = state_24194__$1;
(statearr_24214_24240[(2)] = null);

(statearr_24214_24240[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24195 === (8))){
var inst_24159 = (state_24194[(9)]);
var inst_24163 = figwheel.client.reload_file_state_QMARK_.call(null,inst_24159,opts);
var state_24194__$1 = state_24194;
if(cljs.core.truth_(inst_24163)){
var statearr_24215_24241 = state_24194__$1;
(statearr_24215_24241[(1)] = (11));

} else {
var statearr_24216_24242 = state_24194__$1;
(statearr_24216_24242[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto___24224,ch))
;
return ((function (switch__19660__auto__,c__19725__auto___24224,ch){
return (function() {
var figwheel$client$file_reloader_plugin_$_state_machine__19661__auto__ = null;
var figwheel$client$file_reloader_plugin_$_state_machine__19661__auto____0 = (function (){
var statearr_24220 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_24220[(0)] = figwheel$client$file_reloader_plugin_$_state_machine__19661__auto__);

(statearr_24220[(1)] = (1));

return statearr_24220;
});
var figwheel$client$file_reloader_plugin_$_state_machine__19661__auto____1 = (function (state_24194){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_24194);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e24221){if((e24221 instanceof Object)){
var ex__19664__auto__ = e24221;
var statearr_24222_24243 = state_24194;
(statearr_24222_24243[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_24194);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e24221;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__24244 = state_24194;
state_24194 = G__24244;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
figwheel$client$file_reloader_plugin_$_state_machine__19661__auto__ = function(state_24194){
switch(arguments.length){
case 0:
return figwheel$client$file_reloader_plugin_$_state_machine__19661__auto____0.call(this);
case 1:
return figwheel$client$file_reloader_plugin_$_state_machine__19661__auto____1.call(this,state_24194);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
figwheel$client$file_reloader_plugin_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = figwheel$client$file_reloader_plugin_$_state_machine__19661__auto____0;
figwheel$client$file_reloader_plugin_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = figwheel$client$file_reloader_plugin_$_state_machine__19661__auto____1;
return figwheel$client$file_reloader_plugin_$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___24224,ch))
})();
var state__19727__auto__ = (function (){var statearr_24223 = f__19726__auto__.call(null);
(statearr_24223[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___24224);

return statearr_24223;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___24224,ch))
);


return ((function (ch){
return (function (msg_hist){
cljs.core.async.put_BANG_.call(null,ch,msg_hist);

return msg_hist;
});
;})(ch))
});
figwheel.client.truncate_stack_trace = (function figwheel$client$truncate_stack_trace(stack_str){
return cljs.core.take_while.call(null,(function (p1__24245_SHARP_){
return cljs.core.not.call(null,cljs.core.re_matches.call(null,/.*eval_javascript_STAR__STAR_.*/,p1__24245_SHARP_));
}),clojure.string.split_lines.call(null,stack_str));
});
figwheel.client.get_ua_product = (function figwheel$client$get_ua_product(){
if(cljs.core.truth_(figwheel.client.utils.node_env_QMARK_.call(null))){
return new cljs.core.Keyword(null,"chrome","chrome",1718738387);
} else {
if(cljs.core.truth_(goog.userAgent.product.SAFARI)){
return new cljs.core.Keyword(null,"safari","safari",497115653);
} else {
if(cljs.core.truth_(goog.userAgent.product.CHROME)){
return new cljs.core.Keyword(null,"chrome","chrome",1718738387);
} else {
if(cljs.core.truth_(goog.userAgent.product.FIREFOX)){
return new cljs.core.Keyword(null,"firefox","firefox",1283768880);
} else {
if(cljs.core.truth_(goog.userAgent.product.IE)){
return new cljs.core.Keyword(null,"ie","ie",2038473780);
} else {
return null;
}
}
}
}
}
});
var base_path_24252 = figwheel.client.utils.base_url_path.call(null);
figwheel.client.eval_javascript_STAR__STAR_ = ((function (base_path_24252){
return (function figwheel$client$eval_javascript_STAR__STAR_(code,opts,result_handler){
try{var _STAR_print_fn_STAR_24250 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_newline_STAR_24251 = cljs.core._STAR_print_newline_STAR_;
cljs.core._STAR_print_fn_STAR_ = ((function (_STAR_print_fn_STAR_24250,_STAR_print_newline_STAR_24251,base_path_24252){
return (function() { 
var G__24253__delegate = function (args){
return figwheel.client.figwheel_repl_print.call(null,figwheel.client.console_print.call(null,args));
};
var G__24253 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__24254__i = 0, G__24254__a = new Array(arguments.length -  0);
while (G__24254__i < G__24254__a.length) {G__24254__a[G__24254__i] = arguments[G__24254__i + 0]; ++G__24254__i;}
  args = new cljs.core.IndexedSeq(G__24254__a,0);
} 
return G__24253__delegate.call(this,args);};
G__24253.cljs$lang$maxFixedArity = 0;
G__24253.cljs$lang$applyTo = (function (arglist__24255){
var args = cljs.core.seq(arglist__24255);
return G__24253__delegate(args);
});
G__24253.cljs$core$IFn$_invoke$arity$variadic = G__24253__delegate;
return G__24253;
})()
;})(_STAR_print_fn_STAR_24250,_STAR_print_newline_STAR_24251,base_path_24252))
;

cljs.core._STAR_print_newline_STAR_ = false;

try{return result_handler.call(null,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"success","success",1890645906),new cljs.core.Keyword(null,"ua-product","ua-product",938384227),figwheel.client.get_ua_product.call(null),new cljs.core.Keyword(null,"value","value",305978217),[cljs.core.str(figwheel.client.utils.eval_helper.call(null,code,opts))].join('')], null));
}finally {cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR_24251;

cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR_24250;
}}catch (e24249){if((e24249 instanceof Error)){
var e = e24249;
return result_handler.call(null,new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"exception","exception",-335277064),new cljs.core.Keyword(null,"value","value",305978217),cljs.core.pr_str.call(null,e),new cljs.core.Keyword(null,"ua-product","ua-product",938384227),figwheel.client.get_ua_product.call(null),new cljs.core.Keyword(null,"stacktrace","stacktrace",-95588394),clojure.string.join.call(null,"\n",figwheel.client.truncate_stack_trace.call(null,e.stack)),new cljs.core.Keyword(null,"base-path","base-path",495760020),base_path_24252], null));
} else {
var e = e24249;
return result_handler.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"exception","exception",-335277064),new cljs.core.Keyword(null,"ua-product","ua-product",938384227),figwheel.client.get_ua_product.call(null),new cljs.core.Keyword(null,"value","value",305978217),cljs.core.pr_str.call(null,e),new cljs.core.Keyword(null,"stacktrace","stacktrace",-95588394),"No stacktrace available."], null));

}
}});})(base_path_24252))
;
/**
 * The REPL can disconnect and reconnect lets ensure cljs.user exists at least.
 */
figwheel.client.ensure_cljs_user = (function figwheel$client$ensure_cljs_user(){
if(cljs.core.truth_(cljs.user)){
return null;
} else {
return cljs.user = {};
}
});
figwheel.client.repl_plugin = (function figwheel$client$repl_plugin(p__24256){
var map__24263 = p__24256;
var map__24263__$1 = ((((!((map__24263 == null)))?((((map__24263.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24263.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24263):map__24263);
var opts = map__24263__$1;
var build_id = cljs.core.get.call(null,map__24263__$1,new cljs.core.Keyword(null,"build-id","build-id",1642831089));
return ((function (map__24263,map__24263__$1,opts,build_id){
return (function (p__24265){
var vec__24266 = p__24265;
var map__24267 = cljs.core.nth.call(null,vec__24266,(0),null);
var map__24267__$1 = ((((!((map__24267 == null)))?((((map__24267.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24267.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24267):map__24267);
var msg = map__24267__$1;
var msg_name = cljs.core.get.call(null,map__24267__$1,new cljs.core.Keyword(null,"msg-name","msg-name",-353709863));
var _ = cljs.core.nthnext.call(null,vec__24266,(1));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"repl-eval","repl-eval",-1784727398),msg_name)){
figwheel.client.ensure_cljs_user.call(null);

return figwheel.client.eval_javascript_STAR__STAR_.call(null,new cljs.core.Keyword(null,"code","code",1586293142).cljs$core$IFn$_invoke$arity$1(msg),opts,((function (vec__24266,map__24267,map__24267__$1,msg,msg_name,_,map__24263,map__24263__$1,opts,build_id){
return (function (res){
return figwheel.client.socket.send_BANG_.call(null,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"figwheel-event","figwheel-event",519570592),"callback",new cljs.core.Keyword(null,"callback-name","callback-name",336964714),new cljs.core.Keyword(null,"callback-name","callback-name",336964714).cljs$core$IFn$_invoke$arity$1(msg),new cljs.core.Keyword(null,"content","content",15833224),res], null));
});})(vec__24266,map__24267,map__24267__$1,msg,msg_name,_,map__24263,map__24263__$1,opts,build_id))
);
} else {
return null;
}
});
;})(map__24263,map__24263__$1,opts,build_id))
});
figwheel.client.css_reloader_plugin = (function figwheel$client$css_reloader_plugin(opts){
return (function (p__24273){
var vec__24274 = p__24273;
var map__24275 = cljs.core.nth.call(null,vec__24274,(0),null);
var map__24275__$1 = ((((!((map__24275 == null)))?((((map__24275.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24275.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24275):map__24275);
var msg = map__24275__$1;
var msg_name = cljs.core.get.call(null,map__24275__$1,new cljs.core.Keyword(null,"msg-name","msg-name",-353709863));
var _ = cljs.core.nthnext.call(null,vec__24274,(1));
if(cljs.core._EQ_.call(null,msg_name,new cljs.core.Keyword(null,"css-files-changed","css-files-changed",720773874))){
return figwheel.client.file_reloading.reload_css_files.call(null,opts,msg);
} else {
return null;
}
});
});
figwheel.client.compile_fail_warning_plugin = (function figwheel$client$compile_fail_warning_plugin(p__24277){
var map__24287 = p__24277;
var map__24287__$1 = ((((!((map__24287 == null)))?((((map__24287.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24287.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24287):map__24287);
var on_compile_warning = cljs.core.get.call(null,map__24287__$1,new cljs.core.Keyword(null,"on-compile-warning","on-compile-warning",-1195585947));
var on_compile_fail = cljs.core.get.call(null,map__24287__$1,new cljs.core.Keyword(null,"on-compile-fail","on-compile-fail",728013036));
return ((function (map__24287,map__24287__$1,on_compile_warning,on_compile_fail){
return (function (p__24289){
var vec__24290 = p__24289;
var map__24291 = cljs.core.nth.call(null,vec__24290,(0),null);
var map__24291__$1 = ((((!((map__24291 == null)))?((((map__24291.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24291.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24291):map__24291);
var msg = map__24291__$1;
var msg_name = cljs.core.get.call(null,map__24291__$1,new cljs.core.Keyword(null,"msg-name","msg-name",-353709863));
var _ = cljs.core.nthnext.call(null,vec__24290,(1));
var pred__24293 = cljs.core._EQ_;
var expr__24294 = msg_name;
if(cljs.core.truth_(pred__24293.call(null,new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356),expr__24294))){
return on_compile_warning.call(null,msg);
} else {
if(cljs.core.truth_(pred__24293.call(null,new cljs.core.Keyword(null,"compile-failed","compile-failed",-477639289),expr__24294))){
return on_compile_fail.call(null,msg);
} else {
return null;
}
}
});
;})(map__24287,map__24287__$1,on_compile_warning,on_compile_fail))
});
figwheel.client.heads_up_plugin_msg_handler = (function figwheel$client$heads_up_plugin_msg_handler(opts,msg_hist_SINGLEQUOTE_){
var msg_hist = figwheel.client.focus_msgs.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"compile-failed","compile-failed",-477639289),null,new cljs.core.Keyword(null,"compile-warning","compile-warning",43425356),null,new cljs.core.Keyword(null,"files-changed","files-changed",-1418200563),null], null), null),msg_hist_SINGLEQUOTE_);
var msg_names = cljs.core.map.call(null,new cljs.core.Keyword(null,"msg-name","msg-name",-353709863),msg_hist);
var msg = cljs.core.first.call(null,msg_hist);
var c__19725__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto__,msg_hist,msg_names,msg){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto__,msg_hist,msg_names,msg){
return (function (state_24510){
var state_val_24511 = (state_24510[(1)]);
if((state_val_24511 === (7))){
var inst_24434 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24434)){
var statearr_24512_24558 = state_24510__$1;
(statearr_24512_24558[(1)] = (8));

} else {
var statearr_24513_24559 = state_24510__$1;
(statearr_24513_24559[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (20))){
var inst_24504 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24514_24560 = state_24510__$1;
(statearr_24514_24560[(2)] = inst_24504);

(statearr_24514_24560[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (27))){
var inst_24500 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24515_24561 = state_24510__$1;
(statearr_24515_24561[(2)] = inst_24500);

(statearr_24515_24561[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (1))){
var inst_24427 = figwheel.client.reload_file_state_QMARK_.call(null,msg_names,opts);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24427)){
var statearr_24516_24562 = state_24510__$1;
(statearr_24516_24562[(1)] = (2));

} else {
var statearr_24517_24563 = state_24510__$1;
(statearr_24517_24563[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (24))){
var inst_24502 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24518_24564 = state_24510__$1;
(statearr_24518_24564[(2)] = inst_24502);

(statearr_24518_24564[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (4))){
var inst_24508 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_24510__$1,inst_24508);
} else {
if((state_val_24511 === (15))){
var inst_24506 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24519_24565 = state_24510__$1;
(statearr_24519_24565[(2)] = inst_24506);

(statearr_24519_24565[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (21))){
var inst_24465 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24520_24566 = state_24510__$1;
(statearr_24520_24566[(2)] = inst_24465);

(statearr_24520_24566[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (31))){
var inst_24489 = figwheel.client.css_loaded_state_QMARK_.call(null,msg_names);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24489)){
var statearr_24521_24567 = state_24510__$1;
(statearr_24521_24567[(1)] = (34));

} else {
var statearr_24522_24568 = state_24510__$1;
(statearr_24522_24568[(1)] = (35));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (32))){
var inst_24498 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24523_24569 = state_24510__$1;
(statearr_24523_24569[(2)] = inst_24498);

(statearr_24523_24569[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (33))){
var inst_24487 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24524_24570 = state_24510__$1;
(statearr_24524_24570[(2)] = inst_24487);

(statearr_24524_24570[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (13))){
var inst_24448 = figwheel.client.heads_up.clear.call(null);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(16),inst_24448);
} else {
if((state_val_24511 === (22))){
var inst_24469 = new cljs.core.Keyword(null,"message","message",-406056002).cljs$core$IFn$_invoke$arity$1(msg);
var inst_24470 = figwheel.client.heads_up.append_message.call(null,inst_24469);
var state_24510__$1 = state_24510;
var statearr_24525_24571 = state_24510__$1;
(statearr_24525_24571[(2)] = inst_24470);

(statearr_24525_24571[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (36))){
var inst_24496 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24526_24572 = state_24510__$1;
(statearr_24526_24572[(2)] = inst_24496);

(statearr_24526_24572[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (29))){
var inst_24480 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24527_24573 = state_24510__$1;
(statearr_24527_24573[(2)] = inst_24480);

(statearr_24527_24573[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (6))){
var inst_24429 = (state_24510[(7)]);
var state_24510__$1 = state_24510;
var statearr_24528_24574 = state_24510__$1;
(statearr_24528_24574[(2)] = inst_24429);

(statearr_24528_24574[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (28))){
var inst_24476 = (state_24510[(2)]);
var inst_24477 = new cljs.core.Keyword(null,"message","message",-406056002).cljs$core$IFn$_invoke$arity$1(msg);
var inst_24478 = figwheel.client.heads_up.display_warning.call(null,inst_24477);
var state_24510__$1 = (function (){var statearr_24529 = state_24510;
(statearr_24529[(8)] = inst_24476);

return statearr_24529;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(29),inst_24478);
} else {
if((state_val_24511 === (25))){
var inst_24474 = figwheel.client.heads_up.clear.call(null);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(28),inst_24474);
} else {
if((state_val_24511 === (34))){
var inst_24491 = figwheel.client.heads_up.flash_loaded.call(null);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(37),inst_24491);
} else {
if((state_val_24511 === (17))){
var inst_24456 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24530_24575 = state_24510__$1;
(statearr_24530_24575[(2)] = inst_24456);

(statearr_24530_24575[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (3))){
var inst_24446 = figwheel.client.compile_refail_state_QMARK_.call(null,msg_names);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24446)){
var statearr_24531_24576 = state_24510__$1;
(statearr_24531_24576[(1)] = (13));

} else {
var statearr_24532_24577 = state_24510__$1;
(statearr_24532_24577[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (12))){
var inst_24442 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24533_24578 = state_24510__$1;
(statearr_24533_24578[(2)] = inst_24442);

(statearr_24533_24578[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (2))){
var inst_24429 = (state_24510[(7)]);
var inst_24429__$1 = cljs.core.deref.call(null,figwheel.client.autoload);
var state_24510__$1 = (function (){var statearr_24534 = state_24510;
(statearr_24534[(7)] = inst_24429__$1);

return statearr_24534;
})();
if(cljs.core.truth_(inst_24429__$1)){
var statearr_24535_24579 = state_24510__$1;
(statearr_24535_24579[(1)] = (5));

} else {
var statearr_24536_24580 = state_24510__$1;
(statearr_24536_24580[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (23))){
var inst_24472 = figwheel.client.rewarning_state_QMARK_.call(null,msg_names);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24472)){
var statearr_24537_24581 = state_24510__$1;
(statearr_24537_24581[(1)] = (25));

} else {
var statearr_24538_24582 = state_24510__$1;
(statearr_24538_24582[(1)] = (26));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (35))){
var state_24510__$1 = state_24510;
var statearr_24539_24583 = state_24510__$1;
(statearr_24539_24583[(2)] = null);

(statearr_24539_24583[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (19))){
var inst_24467 = figwheel.client.warning_append_state_QMARK_.call(null,msg_names);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24467)){
var statearr_24540_24584 = state_24510__$1;
(statearr_24540_24584[(1)] = (22));

} else {
var statearr_24541_24585 = state_24510__$1;
(statearr_24541_24585[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (11))){
var inst_24438 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24542_24586 = state_24510__$1;
(statearr_24542_24586[(2)] = inst_24438);

(statearr_24542_24586[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (9))){
var inst_24440 = figwheel.client.heads_up.clear.call(null);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(12),inst_24440);
} else {
if((state_val_24511 === (5))){
var inst_24431 = new cljs.core.Keyword(null,"autoload","autoload",-354122500).cljs$core$IFn$_invoke$arity$1(opts);
var state_24510__$1 = state_24510;
var statearr_24543_24587 = state_24510__$1;
(statearr_24543_24587[(2)] = inst_24431);

(statearr_24543_24587[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (14))){
var inst_24458 = figwheel.client.compile_fail_state_QMARK_.call(null,msg_names);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24458)){
var statearr_24544_24588 = state_24510__$1;
(statearr_24544_24588[(1)] = (18));

} else {
var statearr_24545_24589 = state_24510__$1;
(statearr_24545_24589[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (26))){
var inst_24482 = figwheel.client.warning_state_QMARK_.call(null,msg_names);
var state_24510__$1 = state_24510;
if(cljs.core.truth_(inst_24482)){
var statearr_24546_24590 = state_24510__$1;
(statearr_24546_24590[(1)] = (30));

} else {
var statearr_24547_24591 = state_24510__$1;
(statearr_24547_24591[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (16))){
var inst_24450 = (state_24510[(2)]);
var inst_24451 = new cljs.core.Keyword(null,"exception-data","exception-data",-512474886).cljs$core$IFn$_invoke$arity$1(msg);
var inst_24452 = figwheel.client.format_messages.call(null,inst_24451);
var inst_24453 = new cljs.core.Keyword(null,"cause","cause",231901252).cljs$core$IFn$_invoke$arity$1(msg);
var inst_24454 = figwheel.client.heads_up.display_error.call(null,inst_24452,inst_24453);
var state_24510__$1 = (function (){var statearr_24548 = state_24510;
(statearr_24548[(9)] = inst_24450);

return statearr_24548;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(17),inst_24454);
} else {
if((state_val_24511 === (30))){
var inst_24484 = new cljs.core.Keyword(null,"message","message",-406056002).cljs$core$IFn$_invoke$arity$1(msg);
var inst_24485 = figwheel.client.heads_up.display_warning.call(null,inst_24484);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(33),inst_24485);
} else {
if((state_val_24511 === (10))){
var inst_24444 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24549_24592 = state_24510__$1;
(statearr_24549_24592[(2)] = inst_24444);

(statearr_24549_24592[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (18))){
var inst_24460 = new cljs.core.Keyword(null,"exception-data","exception-data",-512474886).cljs$core$IFn$_invoke$arity$1(msg);
var inst_24461 = figwheel.client.format_messages.call(null,inst_24460);
var inst_24462 = new cljs.core.Keyword(null,"cause","cause",231901252).cljs$core$IFn$_invoke$arity$1(msg);
var inst_24463 = figwheel.client.heads_up.display_error.call(null,inst_24461,inst_24462);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(21),inst_24463);
} else {
if((state_val_24511 === (37))){
var inst_24493 = (state_24510[(2)]);
var state_24510__$1 = state_24510;
var statearr_24550_24593 = state_24510__$1;
(statearr_24550_24593[(2)] = inst_24493);

(statearr_24550_24593[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24511 === (8))){
var inst_24436 = figwheel.client.heads_up.flash_loaded.call(null);
var state_24510__$1 = state_24510;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24510__$1,(11),inst_24436);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__19725__auto__,msg_hist,msg_names,msg))
;
return ((function (switch__19660__auto__,c__19725__auto__,msg_hist,msg_names,msg){
return (function() {
var figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto__ = null;
var figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto____0 = (function (){
var statearr_24554 = [null,null,null,null,null,null,null,null,null,null];
(statearr_24554[(0)] = figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto__);

(statearr_24554[(1)] = (1));

return statearr_24554;
});
var figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto____1 = (function (state_24510){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_24510);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e24555){if((e24555 instanceof Object)){
var ex__19664__auto__ = e24555;
var statearr_24556_24594 = state_24510;
(statearr_24556_24594[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_24510);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e24555;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__24595 = state_24510;
state_24510 = G__24595;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto__ = function(state_24510){
switch(arguments.length){
case 0:
return figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto____0.call(this);
case 1:
return figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto____1.call(this,state_24510);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto____0;
figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto____1;
return figwheel$client$heads_up_plugin_msg_handler_$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto__,msg_hist,msg_names,msg))
})();
var state__19727__auto__ = (function (){var statearr_24557 = f__19726__auto__.call(null);
(statearr_24557[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto__);

return statearr_24557;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto__,msg_hist,msg_names,msg))
);

return c__19725__auto__;
});
figwheel.client.heads_up_plugin = (function figwheel$client$heads_up_plugin(opts){
var ch = cljs.core.async.chan.call(null);
figwheel.client.heads_up_config_options_STAR__STAR_ = opts;

var c__19725__auto___24658 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto___24658,ch){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto___24658,ch){
return (function (state_24641){
var state_val_24642 = (state_24641[(1)]);
if((state_val_24642 === (1))){
var state_24641__$1 = state_24641;
var statearr_24643_24659 = state_24641__$1;
(statearr_24643_24659[(2)] = null);

(statearr_24643_24659[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24642 === (2))){
var state_24641__$1 = state_24641;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24641__$1,(4),ch);
} else {
if((state_val_24642 === (3))){
var inst_24639 = (state_24641[(2)]);
var state_24641__$1 = state_24641;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_24641__$1,inst_24639);
} else {
if((state_val_24642 === (4))){
var inst_24629 = (state_24641[(7)]);
var inst_24629__$1 = (state_24641[(2)]);
var state_24641__$1 = (function (){var statearr_24644 = state_24641;
(statearr_24644[(7)] = inst_24629__$1);

return statearr_24644;
})();
if(cljs.core.truth_(inst_24629__$1)){
var statearr_24645_24660 = state_24641__$1;
(statearr_24645_24660[(1)] = (5));

} else {
var statearr_24646_24661 = state_24641__$1;
(statearr_24646_24661[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24642 === (5))){
var inst_24629 = (state_24641[(7)]);
var inst_24631 = figwheel.client.heads_up_plugin_msg_handler.call(null,opts,inst_24629);
var state_24641__$1 = state_24641;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24641__$1,(8),inst_24631);
} else {
if((state_val_24642 === (6))){
var state_24641__$1 = state_24641;
var statearr_24647_24662 = state_24641__$1;
(statearr_24647_24662[(2)] = null);

(statearr_24647_24662[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24642 === (7))){
var inst_24637 = (state_24641[(2)]);
var state_24641__$1 = state_24641;
var statearr_24648_24663 = state_24641__$1;
(statearr_24648_24663[(2)] = inst_24637);

(statearr_24648_24663[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_24642 === (8))){
var inst_24633 = (state_24641[(2)]);
var state_24641__$1 = (function (){var statearr_24649 = state_24641;
(statearr_24649[(8)] = inst_24633);

return statearr_24649;
})();
var statearr_24650_24664 = state_24641__$1;
(statearr_24650_24664[(2)] = null);

(statearr_24650_24664[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__19725__auto___24658,ch))
;
return ((function (switch__19660__auto__,c__19725__auto___24658,ch){
return (function() {
var figwheel$client$heads_up_plugin_$_state_machine__19661__auto__ = null;
var figwheel$client$heads_up_plugin_$_state_machine__19661__auto____0 = (function (){
var statearr_24654 = [null,null,null,null,null,null,null,null,null];
(statearr_24654[(0)] = figwheel$client$heads_up_plugin_$_state_machine__19661__auto__);

(statearr_24654[(1)] = (1));

return statearr_24654;
});
var figwheel$client$heads_up_plugin_$_state_machine__19661__auto____1 = (function (state_24641){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_24641);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e24655){if((e24655 instanceof Object)){
var ex__19664__auto__ = e24655;
var statearr_24656_24665 = state_24641;
(statearr_24656_24665[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_24641);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e24655;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__24666 = state_24641;
state_24641 = G__24666;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
figwheel$client$heads_up_plugin_$_state_machine__19661__auto__ = function(state_24641){
switch(arguments.length){
case 0:
return figwheel$client$heads_up_plugin_$_state_machine__19661__auto____0.call(this);
case 1:
return figwheel$client$heads_up_plugin_$_state_machine__19661__auto____1.call(this,state_24641);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
figwheel$client$heads_up_plugin_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = figwheel$client$heads_up_plugin_$_state_machine__19661__auto____0;
figwheel$client$heads_up_plugin_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = figwheel$client$heads_up_plugin_$_state_machine__19661__auto____1;
return figwheel$client$heads_up_plugin_$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto___24658,ch))
})();
var state__19727__auto__ = (function (){var statearr_24657 = f__19726__auto__.call(null);
(statearr_24657[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto___24658);

return statearr_24657;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto___24658,ch))
);


figwheel.client.heads_up.ensure_container.call(null);

return ((function (ch){
return (function (msg_hist){
cljs.core.async.put_BANG_.call(null,ch,msg_hist);

return msg_hist;
});
;})(ch))
});
figwheel.client.enforce_project_plugin = (function figwheel$client$enforce_project_plugin(opts){
return (function (msg_hist){
if(((1) < cljs.core.count.call(null,cljs.core.set.call(null,cljs.core.keep.call(null,new cljs.core.Keyword(null,"project-id","project-id",206449307),cljs.core.take.call(null,(5),msg_hist)))))){
figwheel.client.socket.close_BANG_.call(null);

console.error("Figwheel: message received from different project. Shutting socket down.");

if(cljs.core.truth_(new cljs.core.Keyword(null,"heads-up-display","heads-up-display",-896577202).cljs$core$IFn$_invoke$arity$1(opts))){
var c__19725__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__19725__auto__){
return (function (){
var f__19726__auto__ = (function (){var switch__19660__auto__ = ((function (c__19725__auto__){
return (function (state_24687){
var state_val_24688 = (state_24687[(1)]);
if((state_val_24688 === (1))){
var inst_24682 = cljs.core.async.timeout.call(null,(3000));
var state_24687__$1 = state_24687;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_24687__$1,(2),inst_24682);
} else {
if((state_val_24688 === (2))){
var inst_24684 = (state_24687[(2)]);
var inst_24685 = figwheel.client.heads_up.display_system_warning.call(null,"Connection from different project","Shutting connection down!!!!!");
var state_24687__$1 = (function (){var statearr_24689 = state_24687;
(statearr_24689[(7)] = inst_24684);

return statearr_24689;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_24687__$1,inst_24685);
} else {
return null;
}
}
});})(c__19725__auto__))
;
return ((function (switch__19660__auto__,c__19725__auto__){
return (function() {
var figwheel$client$enforce_project_plugin_$_state_machine__19661__auto__ = null;
var figwheel$client$enforce_project_plugin_$_state_machine__19661__auto____0 = (function (){
var statearr_24693 = [null,null,null,null,null,null,null,null];
(statearr_24693[(0)] = figwheel$client$enforce_project_plugin_$_state_machine__19661__auto__);

(statearr_24693[(1)] = (1));

return statearr_24693;
});
var figwheel$client$enforce_project_plugin_$_state_machine__19661__auto____1 = (function (state_24687){
while(true){
var ret_value__19662__auto__ = (function (){try{while(true){
var result__19663__auto__ = switch__19660__auto__.call(null,state_24687);
if(cljs.core.keyword_identical_QMARK_.call(null,result__19663__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__19663__auto__;
}
break;
}
}catch (e24694){if((e24694 instanceof Object)){
var ex__19664__auto__ = e24694;
var statearr_24695_24697 = state_24687;
(statearr_24695_24697[(5)] = ex__19664__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_24687);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e24694;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__19662__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__24698 = state_24687;
state_24687 = G__24698;
continue;
} else {
return ret_value__19662__auto__;
}
break;
}
});
figwheel$client$enforce_project_plugin_$_state_machine__19661__auto__ = function(state_24687){
switch(arguments.length){
case 0:
return figwheel$client$enforce_project_plugin_$_state_machine__19661__auto____0.call(this);
case 1:
return figwheel$client$enforce_project_plugin_$_state_machine__19661__auto____1.call(this,state_24687);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
figwheel$client$enforce_project_plugin_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$0 = figwheel$client$enforce_project_plugin_$_state_machine__19661__auto____0;
figwheel$client$enforce_project_plugin_$_state_machine__19661__auto__.cljs$core$IFn$_invoke$arity$1 = figwheel$client$enforce_project_plugin_$_state_machine__19661__auto____1;
return figwheel$client$enforce_project_plugin_$_state_machine__19661__auto__;
})()
;})(switch__19660__auto__,c__19725__auto__))
})();
var state__19727__auto__ = (function (){var statearr_24696 = f__19726__auto__.call(null);
(statearr_24696[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__19725__auto__);

return statearr_24696;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__19727__auto__);
});})(c__19725__auto__))
);

return c__19725__auto__;
} else {
return null;
}
} else {
return null;
}
});
});
figwheel.client.default_on_jsload = cljs.core.identity;
figwheel.client.default_on_compile_fail = (function figwheel$client$default_on_compile_fail(p__24699){
var map__24706 = p__24699;
var map__24706__$1 = ((((!((map__24706 == null)))?((((map__24706.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24706.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24706):map__24706);
var ed = map__24706__$1;
var formatted_exception = cljs.core.get.call(null,map__24706__$1,new cljs.core.Keyword(null,"formatted-exception","formatted-exception",-116489026));
var exception_data = cljs.core.get.call(null,map__24706__$1,new cljs.core.Keyword(null,"exception-data","exception-data",-512474886));
var cause = cljs.core.get.call(null,map__24706__$1,new cljs.core.Keyword(null,"cause","cause",231901252));
figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"debug","debug",-1608172596),"Figwheel: Compile Exception");

var seq__24708_24712 = cljs.core.seq.call(null,figwheel.client.format_messages.call(null,exception_data));
var chunk__24709_24713 = null;
var count__24710_24714 = (0);
var i__24711_24715 = (0);
while(true){
if((i__24711_24715 < count__24710_24714)){
var msg_24716 = cljs.core._nth.call(null,chunk__24709_24713,i__24711_24715);
figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"info","info",-317069002),msg_24716);

var G__24717 = seq__24708_24712;
var G__24718 = chunk__24709_24713;
var G__24719 = count__24710_24714;
var G__24720 = (i__24711_24715 + (1));
seq__24708_24712 = G__24717;
chunk__24709_24713 = G__24718;
count__24710_24714 = G__24719;
i__24711_24715 = G__24720;
continue;
} else {
var temp__4425__auto___24721 = cljs.core.seq.call(null,seq__24708_24712);
if(temp__4425__auto___24721){
var seq__24708_24722__$1 = temp__4425__auto___24721;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__24708_24722__$1)){
var c__17199__auto___24723 = cljs.core.chunk_first.call(null,seq__24708_24722__$1);
var G__24724 = cljs.core.chunk_rest.call(null,seq__24708_24722__$1);
var G__24725 = c__17199__auto___24723;
var G__24726 = cljs.core.count.call(null,c__17199__auto___24723);
var G__24727 = (0);
seq__24708_24712 = G__24724;
chunk__24709_24713 = G__24725;
count__24710_24714 = G__24726;
i__24711_24715 = G__24727;
continue;
} else {
var msg_24728 = cljs.core.first.call(null,seq__24708_24722__$1);
figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"info","info",-317069002),msg_24728);

var G__24729 = cljs.core.next.call(null,seq__24708_24722__$1);
var G__24730 = null;
var G__24731 = (0);
var G__24732 = (0);
seq__24708_24712 = G__24729;
chunk__24709_24713 = G__24730;
count__24710_24714 = G__24731;
i__24711_24715 = G__24732;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(cause)){
figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"info","info",-317069002),[cljs.core.str("Error on file "),cljs.core.str(new cljs.core.Keyword(null,"file","file",-1269645878).cljs$core$IFn$_invoke$arity$1(cause)),cljs.core.str(", line "),cljs.core.str(new cljs.core.Keyword(null,"line","line",212345235).cljs$core$IFn$_invoke$arity$1(cause)),cljs.core.str(", column "),cljs.core.str(new cljs.core.Keyword(null,"column","column",2078222095).cljs$core$IFn$_invoke$arity$1(cause))].join(''));
} else {
}

return ed;
});
figwheel.client.default_on_compile_warning = (function figwheel$client$default_on_compile_warning(p__24733){
var map__24736 = p__24733;
var map__24736__$1 = ((((!((map__24736 == null)))?((((map__24736.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24736.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24736):map__24736);
var w = map__24736__$1;
var message = cljs.core.get.call(null,map__24736__$1,new cljs.core.Keyword(null,"message","message",-406056002));
figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"warn","warn",-436710552),[cljs.core.str("Figwheel: Compile Warning - "),cljs.core.str(message)].join(''));

return w;
});
figwheel.client.default_before_load = (function figwheel$client$default_before_load(files){
figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"debug","debug",-1608172596),"Figwheel: notified of file changes");

return files;
});
figwheel.client.default_on_cssload = (function figwheel$client$default_on_cssload(files){
figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"debug","debug",-1608172596),"Figwheel: loaded CSS files");

figwheel.client.utils.log.call(null,new cljs.core.Keyword(null,"info","info",-317069002),cljs.core.pr_str.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"file","file",-1269645878),files)));

return files;
});
if(typeof figwheel.client.config_defaults !== 'undefined'){
} else {
figwheel.client.config_defaults = cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"on-compile-warning","on-compile-warning",-1195585947),new cljs.core.Keyword(null,"on-jsload","on-jsload",-395756602),new cljs.core.Keyword(null,"reload-dependents","reload-dependents",-956865430),new cljs.core.Keyword(null,"on-compile-fail","on-compile-fail",728013036),new cljs.core.Keyword(null,"debug","debug",-1608172596),new cljs.core.Keyword(null,"heads-up-display","heads-up-display",-896577202),new cljs.core.Keyword(null,"websocket-url","websocket-url",-490444938),new cljs.core.Keyword(null,"before-jsload","before-jsload",-847513128),new cljs.core.Keyword(null,"load-warninged-code","load-warninged-code",-2030345223),new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294),new cljs.core.Keyword(null,"retry-count","retry-count",1936122875),new cljs.core.Keyword(null,"autoload","autoload",-354122500),new cljs.core.Keyword(null,"on-cssload","on-cssload",1825432318)],[figwheel.client.default_on_compile_warning,figwheel.client.default_on_jsload,true,figwheel.client.default_on_compile_fail,false,true,[cljs.core.str("ws://"),cljs.core.str((cljs.core.truth_(figwheel.client.utils.html_env_QMARK_.call(null))?location.host:"localhost:3449")),cljs.core.str("/figwheel-ws")].join(''),figwheel.client.default_before_load,false,false,(100),true,figwheel.client.default_on_cssload]);
}
figwheel.client.handle_deprecated_jsload_callback = (function figwheel$client$handle_deprecated_jsload_callback(config){
if(cljs.core.truth_(new cljs.core.Keyword(null,"jsload-callback","jsload-callback",-1949628369).cljs$core$IFn$_invoke$arity$1(config))){
return cljs.core.dissoc.call(null,cljs.core.assoc.call(null,config,new cljs.core.Keyword(null,"on-jsload","on-jsload",-395756602),new cljs.core.Keyword(null,"jsload-callback","jsload-callback",-1949628369).cljs$core$IFn$_invoke$arity$1(config)),new cljs.core.Keyword(null,"jsload-callback","jsload-callback",-1949628369));
} else {
return config;
}
});
figwheel.client.base_plugins = (function figwheel$client$base_plugins(system_options){
var base = new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"enforce-project-plugin","enforce-project-plugin",959402899),figwheel.client.enforce_project_plugin,new cljs.core.Keyword(null,"file-reloader-plugin","file-reloader-plugin",-1792964733),figwheel.client.file_reloader_plugin,new cljs.core.Keyword(null,"comp-fail-warning-plugin","comp-fail-warning-plugin",634311),figwheel.client.compile_fail_warning_plugin,new cljs.core.Keyword(null,"css-reloader-plugin","css-reloader-plugin",2002032904),figwheel.client.css_reloader_plugin,new cljs.core.Keyword(null,"repl-plugin","repl-plugin",-1138952371),figwheel.client.repl_plugin], null);
var base__$1 = ((cljs.core.not.call(null,figwheel.client.utils.html_env_QMARK_.call(null)))?cljs.core.select_keys.call(null,base,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"file-reloader-plugin","file-reloader-plugin",-1792964733),new cljs.core.Keyword(null,"comp-fail-warning-plugin","comp-fail-warning-plugin",634311),new cljs.core.Keyword(null,"repl-plugin","repl-plugin",-1138952371)], null)):base);
var base__$2 = ((new cljs.core.Keyword(null,"autoload","autoload",-354122500).cljs$core$IFn$_invoke$arity$1(system_options) === false)?cljs.core.dissoc.call(null,base__$1,new cljs.core.Keyword(null,"file-reloader-plugin","file-reloader-plugin",-1792964733)):base__$1);
if(cljs.core.truth_((function (){var and__16384__auto__ = new cljs.core.Keyword(null,"heads-up-display","heads-up-display",-896577202).cljs$core$IFn$_invoke$arity$1(system_options);
if(cljs.core.truth_(and__16384__auto__)){
return figwheel.client.utils.html_env_QMARK_.call(null);
} else {
return and__16384__auto__;
}
})())){
return cljs.core.assoc.call(null,base__$2,new cljs.core.Keyword(null,"heads-up-display-plugin","heads-up-display-plugin",1745207501),figwheel.client.heads_up_plugin);
} else {
return base__$2;
}
});
figwheel.client.add_plugins = (function figwheel$client$add_plugins(plugins,system_options){
var seq__24744 = cljs.core.seq.call(null,plugins);
var chunk__24745 = null;
var count__24746 = (0);
var i__24747 = (0);
while(true){
if((i__24747 < count__24746)){
var vec__24748 = cljs.core._nth.call(null,chunk__24745,i__24747);
var k = cljs.core.nth.call(null,vec__24748,(0),null);
var plugin = cljs.core.nth.call(null,vec__24748,(1),null);
if(cljs.core.truth_(plugin)){
var pl_24750 = plugin.call(null,system_options);
cljs.core.add_watch.call(null,figwheel.client.socket.message_history_atom,k,((function (seq__24744,chunk__24745,count__24746,i__24747,pl_24750,vec__24748,k,plugin){
return (function (_,___$1,___$2,msg_hist){
return pl_24750.call(null,msg_hist);
});})(seq__24744,chunk__24745,count__24746,i__24747,pl_24750,vec__24748,k,plugin))
);
} else {
}

var G__24751 = seq__24744;
var G__24752 = chunk__24745;
var G__24753 = count__24746;
var G__24754 = (i__24747 + (1));
seq__24744 = G__24751;
chunk__24745 = G__24752;
count__24746 = G__24753;
i__24747 = G__24754;
continue;
} else {
var temp__4425__auto__ = cljs.core.seq.call(null,seq__24744);
if(temp__4425__auto__){
var seq__24744__$1 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__24744__$1)){
var c__17199__auto__ = cljs.core.chunk_first.call(null,seq__24744__$1);
var G__24755 = cljs.core.chunk_rest.call(null,seq__24744__$1);
var G__24756 = c__17199__auto__;
var G__24757 = cljs.core.count.call(null,c__17199__auto__);
var G__24758 = (0);
seq__24744 = G__24755;
chunk__24745 = G__24756;
count__24746 = G__24757;
i__24747 = G__24758;
continue;
} else {
var vec__24749 = cljs.core.first.call(null,seq__24744__$1);
var k = cljs.core.nth.call(null,vec__24749,(0),null);
var plugin = cljs.core.nth.call(null,vec__24749,(1),null);
if(cljs.core.truth_(plugin)){
var pl_24759 = plugin.call(null,system_options);
cljs.core.add_watch.call(null,figwheel.client.socket.message_history_atom,k,((function (seq__24744,chunk__24745,count__24746,i__24747,pl_24759,vec__24749,k,plugin,seq__24744__$1,temp__4425__auto__){
return (function (_,___$1,___$2,msg_hist){
return pl_24759.call(null,msg_hist);
});})(seq__24744,chunk__24745,count__24746,i__24747,pl_24759,vec__24749,k,plugin,seq__24744__$1,temp__4425__auto__))
);
} else {
}

var G__24760 = cljs.core.next.call(null,seq__24744__$1);
var G__24761 = null;
var G__24762 = (0);
var G__24763 = (0);
seq__24744 = G__24760;
chunk__24745 = G__24761;
count__24746 = G__24762;
i__24747 = G__24763;
continue;
}
} else {
return null;
}
}
break;
}
});
figwheel.client.start = (function figwheel$client$start(var_args){
var args24764 = [];
var len__17454__auto___24767 = arguments.length;
var i__17455__auto___24768 = (0);
while(true){
if((i__17455__auto___24768 < len__17454__auto___24767)){
args24764.push((arguments[i__17455__auto___24768]));

var G__24769 = (i__17455__auto___24768 + (1));
i__17455__auto___24768 = G__24769;
continue;
} else {
}
break;
}

var G__24766 = args24764.length;
switch (G__24766) {
case 1:
return figwheel.client.start.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 0:
return figwheel.client.start.cljs$core$IFn$_invoke$arity$0();

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args24764.length)].join('')));

}
});

figwheel.client.start.cljs$core$IFn$_invoke$arity$1 = (function (opts){
if((goog.dependencies_ == null)){
return null;
} else {
if(typeof figwheel.client.__figwheel_start_once__ !== 'undefined'){
return null;
} else {
figwheel.client.__figwheel_start_once__ = setTimeout((function (){
var plugins_SINGLEQUOTE_ = new cljs.core.Keyword(null,"plugins","plugins",1900073717).cljs$core$IFn$_invoke$arity$1(opts);
var merge_plugins = new cljs.core.Keyword(null,"merge-plugins","merge-plugins",-1193912370).cljs$core$IFn$_invoke$arity$1(opts);
var system_options = figwheel.client.handle_deprecated_jsload_callback.call(null,cljs.core.merge.call(null,figwheel.client.config_defaults,cljs.core.dissoc.call(null,opts,new cljs.core.Keyword(null,"plugins","plugins",1900073717),new cljs.core.Keyword(null,"merge-plugins","merge-plugins",-1193912370))));
var plugins = (cljs.core.truth_(plugins_SINGLEQUOTE_)?plugins_SINGLEQUOTE_:cljs.core.merge.call(null,figwheel.client.base_plugins.call(null,system_options),merge_plugins));
figwheel.client.utils._STAR_print_debug_STAR_ = new cljs.core.Keyword(null,"debug","debug",-1608172596).cljs$core$IFn$_invoke$arity$1(opts);

figwheel.client.add_plugins.call(null,plugins,system_options);

figwheel.client.file_reloading.patch_goog_base.call(null);

return figwheel.client.socket.open.call(null,system_options);
}));
}
}
});

figwheel.client.start.cljs$core$IFn$_invoke$arity$0 = (function (){
return figwheel.client.start.call(null,cljs.core.PersistentArrayMap.EMPTY);
});

figwheel.client.start.cljs$lang$maxFixedArity = 1;
figwheel.client.watch_and_reload_with_opts = figwheel.client.start;
figwheel.client.watch_and_reload = (function figwheel$client$watch_and_reload(var_args){
var args__17461__auto__ = [];
var len__17454__auto___24775 = arguments.length;
var i__17455__auto___24776 = (0);
while(true){
if((i__17455__auto___24776 < len__17454__auto___24775)){
args__17461__auto__.push((arguments[i__17455__auto___24776]));

var G__24777 = (i__17455__auto___24776 + (1));
i__17455__auto___24776 = G__24777;
continue;
} else {
}
break;
}

var argseq__17462__auto__ = ((((0) < args__17461__auto__.length))?(new cljs.core.IndexedSeq(args__17461__auto__.slice((0)),(0))):null);
return figwheel.client.watch_and_reload.cljs$core$IFn$_invoke$arity$variadic(argseq__17462__auto__);
});

figwheel.client.watch_and_reload.cljs$core$IFn$_invoke$arity$variadic = (function (p__24772){
var map__24773 = p__24772;
var map__24773__$1 = ((((!((map__24773 == null)))?((((map__24773.cljs$lang$protocol_mask$partition0$ & (64))) || (map__24773.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__24773):map__24773);
var opts = map__24773__$1;
return figwheel.client.start.call(null,opts);
});

figwheel.client.watch_and_reload.cljs$lang$maxFixedArity = (0);

figwheel.client.watch_and_reload.cljs$lang$applyTo = (function (seq24771){
return figwheel.client.watch_and_reload.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq24771));
});

//# sourceMappingURL=client.js.map